	
	include \masm64\include64\masm64rt.inc
	includelib \masm64\lib64\ntdll.lib
	includelib \masm64\lib64\kernel32.lib

.data
hCon	QWORD ?
pFiber	QWORD ?
pFiber0	QWORD ?
dBuffer	QWORD ?

.code
externdef __imp_ConvertThreadToFiber:PPROC
ConvertThreadToFiber equ <__imp_ConvertThreadToFiber>

externdef __imp_CreateFiber:PPROC
CreateFiber equ <__imp_CreateFiber>

externdef __imp_DbgPrint:PPROC
DbgPrint equ <__imp_DbgPrint>

externdef __imp_vsprintf:PPROC
vsprintf equ <__imp_vsprintf>

Print proc
Local Args:QWORD
Local N:DWORD
Local Buffer[64]:BYTE
	mov Args,rdx
	mov rdx,rcx
	lea r8,Args

	lea rcx,Buffer
	Call vsprintf
	invoke WriteConsole, hCon, addr Buffer, rAx, addr N, 0
  	ret
Print endp

Fiber proc p1:QWORD
Lp:
	sub rsp,dBuffer
	and qword ptr [rsp],0
	
	invoke Print, addr psp$, rSp
	mov rax,qword ptr gs:[8]
	mov rdx,qword ptr gs:[16]
	sub rax,rdx
	
	invoke Print, addr ssp$, rAx
	invoke SwitchToFiber, pFiber0
L0::
	jmp Lp
Fiber endp

psp$	db "@SP: 0x%X, ", 0
ssp$	db "S:0x%X", 13, 10, 0

EP proc
	and rsp,not(15)
	
	invoke AllocConsole
	invoke GetStdHandle, STD_OUTPUT_HANDLE
	mov hCon,rax
	
	invoke CreateFiber, 0, addr Fiber, 123h
	mov pFiber,rax

	invoke ConvertThreadToFiber, 345h
	mov pFiber0,rax
	
	mov dBuffer,64
	invoke SwitchToFiber, pFiber	; Fiber() -> SwitchToFiber() -> L1
L1::
	mov dBuffer,64
	invoke SwitchToFiber, pFiber	; Fiber().L0 -> SwitchToFiber() -> L2
L2::
	mov dBuffer,64
	invoke SwitchToFiber, pFiber	; Fiber().L0 -> SwitchToFiber() -> L3
	
	mov rbx,16
L3::
	mov dBuffer,1000h
	invoke SwitchToFiber, pFiber
	dec rbx
	jnz L3
	invoke Sleep, INFINITE
	ret
EP endp
end